//    Copyright 2025 Bill Rossi
//    
//    This file is part of Hanafuda Hachi-Hachi.
//
//    Hanafuda Hachi-Hachi is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//
//    Hanafuda Hachi-Hachi is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along with Hanafuda Hachi-Hachi. If not, see <https://www.gnu.org/licenses/>. 
#ifndef _HF_DEKIYAKU_
#define _HF_DEKIYAKU_

#include "card.h"

typedef enum DekiyakuAction {
  DEKIYAKU_ACTION_NONE,
  DEKIYAKU_ACTION_SAGE,
  DEKIYAKU_ACTION_SHOUBU,
  DEKIYAKU_ACTION_CANCEL,
} DekiyakuAction;

typedef enum DekiyakuMeldType {
  NONE,
  FIVE_BRIGHTS,
  FOUR_BRIGHTS,
  SEVEN_RIBBONS,
  POETRY_RIBBONS,
  BLUE_RIBBONS,
  BOAR_DEER_BUTTERFLIES,
} DekiyakuMeldType;

typedef struct DekiyakuMeld {
  DekiyakuMeldType type;
  int value;
} DekiyakuMeld;

typedef struct Dekiyaku {
  DekiyakuMeld meld[5];
  int count;
} Dekiyaku;

void calculate_dekiyaku(Hand *h, Dekiyaku *d);
char *meld_name(DekiyakuMeldType d);
void dekiyaku_to_string(Dekiyaku *d, char *str);
int dekiyaku_score(Dekiyaku *d);

#endif
