//    Copyright 2025 Bill Rossi
//    
//    This file is part of Hanafuda Hachi-Hachi.
//
//    Hanafuda Hachi-Hachi is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//
//    Hanafuda Hachi-Hachi is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along with Hanafuda Hachi-Hachi. If not, see <https://www.gnu.org/licenses/>. 
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <string.h>
#include <time.h>

#include <raylib.h>

#include "intro.h"
#include "game.h"

int main(int argc, char** argv) {
  srand(time(NULL));
  InitWindow(1400, 900, "Hanafuda Hachi-Hachi");
  SetTargetFPS(60);

  if (!getenv("SKIP_INTRO") || strcmp(getenv("SKIP_INTRO"), "1") != 0) {
    display_loading();
    Intro *i = load_intro();
    intro_display(i);
  }

  Game g;
  initialize_game(&g);

  run_until_closing(&g);
      
  CloseWindow();
  return 0;
}
