//    Copyright 2025 Bill Rossi
//    
//    This file is part of Hanafuda Hachi-Hachi.
//
//    Hanafuda Hachi-Hachi is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//
//    Hanafuda Hachi-Hachi is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along with Hanafuda Hachi-Hachi. If not, see <https://www.gnu.org/licenses/>. 
#ifndef _HF_OPTIONS_
#define _HF_OPTIONS_

typedef struct Options Options;
typedef struct OptionsChoices OptionsChoices;

#include "game.h"

struct Options {
  int kan_value;
  int number_of_rounds;
  int card_backs;
  int deal_speed;
};

struct OptionsChoices {
  char *choice[5];
  int count;
  int y;
  void (*handle)(Game*, int);
};

void load_options_from_game(Game *g);
void save_options_to_game(Game *g);
void options_handle_input(Game *g);
void options_draw(Game *g);
void DrawTextCentered(char *text, int center_x, int y, int point, Color color);

#endif
