//    Copyright 2025 Bill Rossi
//    
//    This file is part of Hanafuda Hachi-Hachi.
//
//    Hanafuda Hachi-Hachi is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//
//    Hanafuda Hachi-Hachi is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along with Hanafuda Hachi-Hachi. If not, see <https://www.gnu.org/licenses/>. 
#ifndef _HF_PLAYER_
#define _HF_PLAYER_

typedef struct Player Player;
typedef enum PlayerSeat {
  PLAYER,
  RIGHT,
  LEFT
} PlayerSeat;

#include "card.h"

struct Player {
  PlayerSeat seat;
  char *name;
  Hand hand, scored;
  Teyaku teyaku;
  Dekiyaku dekiyaku;
  DekiyakuAction dekiyaku_action;
  int dekiyaku_score;
  int points;
  int last_round_points;
  char points_string[20];
  char teyaku_string[50];
  bool ai;
  bool dealer;
};

#endif
