//    Copyright 2025 Bill Rossi
//    
//    This file is part of Hanafuda Hachi-Hachi.
//
//    Hanafuda Hachi-Hachi is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//
//    Hanafuda Hachi-Hachi is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along with Hanafuda Hachi-Hachi. If not, see <https://www.gnu.org/licenses/>. 
#ifndef _HF_SPECIAL_CASES_
#define _HF_SPECIAL_CASES_

typedef struct SpecialCase SpecialCase;
typedef enum SpecialCaseType {
  SPECIAL_CASE_NONE,
  SPECIAL_CASE_ALL_EIGHTS,
  SPECIAL_CASE_DOUBLE_EIGHTS,
  SPECIAL_CASE_SIXTEEN_CHAFF,
} SpecialCaseType;

typedef enum SpecialCaseTarget {
  SPECIAL_CASE_TARGET_NONE,
  SPECIAL_CASE_TARGET_DEALER,
  SPECIAL_CASE_TARGET_PLAYER,
  SPECIAL_CASE_TARGET_RIGHT,
  SPECIAL_CASE_TARGET_LEFT,
} SpecialCaseTarget;

#include "game.h"

struct SpecialCase {
  SpecialCaseType type;
  SpecialCaseTarget target;
  int score;
};

SpecialCase calculate_special_case(Game *g);

#endif
